-- ==============================================================
-- File generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2016.2
-- Copyright (C) 1986-2016 Xilinx, Inc. All Rights Reserved.
-- 
-- ==============================================================

library ieee; 
use ieee.std_logic_1164.all; 
use ieee.std_logic_unsigned.all;

entity hls_ciphercore_Simonz_rom is 
    generic(
             dwidth     : integer := 1; 
             awidth     : integer := 6; 
             mem_size    : integer := 64
    ); 
    port (
          addr0      : in std_logic_vector(awidth-1 downto 0); 
          ce0       : in std_logic; 
          q0         : out std_logic_vector(dwidth-1 downto 0);
          clk       : in std_logic
    ); 
end entity; 


architecture rtl of hls_ciphercore_Simonz_rom is 

signal addr0_tmp : std_logic_vector(awidth-1 downto 0); 
type mem_array is array (0 to mem_size-1) of std_logic_vector (dwidth-1 downto 0); 
signal mem : mem_array := (
    0 => "1", 1 => "0", 2 => "1", 3 => "0", 4 to 7=> "1", 8 => "0", 9 to 11=> "1", 
    12 to 17=> "0", 18 to 19=> "1", 20 => "0", 21 => "1", 22 to 23=> "0", 24 => "1", 25 to 26=> "0", 
    27 to 28=> "1", 29 to 31=> "0", 32 => "1", 33 => "0", 34 => "1", 35 to 38=> "0", 39 => "1", 
    40 to 42=> "0", 43 to 48=> "1", 49 to 50=> "0", 51 => "1", 52 => "0", 53 to 54=> "1", 55 => "0", 
    56 to 57=> "1", 58 to 59=> "0", 60 to 61=> "1", 62 to 63=> "0" );


attribute EQUIVALENT_REGISTER_REMOVAL : string;
begin 


memory_access_guard_0: process (addr0) 
begin
      addr0_tmp <= addr0;
--synthesis translate_off
      if (CONV_INTEGER(addr0) > mem_size-1) then
           addr0_tmp <= (others => '0');
      else 
           addr0_tmp <= addr0;
      end if;
--synthesis translate_on
end process;

    q0 <= mem(CONV_INTEGER(addr0_tmp));

end rtl;


Library IEEE;
use IEEE.std_logic_1164.all;

entity hls_ciphercore_Simonz is
    generic (
        DataWidth : INTEGER := 1;
        AddressRange : INTEGER := 64;
        AddressWidth : INTEGER := 6);
    port (
        reset : IN STD_LOGIC;
        clk : IN STD_LOGIC;
        address0 : IN STD_LOGIC_VECTOR(AddressWidth - 1 DOWNTO 0);
        ce0 : IN STD_LOGIC;
        q0 : OUT STD_LOGIC_VECTOR(DataWidth - 1 DOWNTO 0));
end entity;

architecture arch of hls_ciphercore_Simonz is
    component hls_ciphercore_Simonz_rom is
        port (
            clk : IN STD_LOGIC;
            addr0 : IN STD_LOGIC_VECTOR;
            ce0 : IN STD_LOGIC;
            q0 : OUT STD_LOGIC_VECTOR);
    end component;



begin
    hls_ciphercore_Simonz_rom_U :  component hls_ciphercore_Simonz_rom
    port map (
        clk => clk,
        addr0 => address0,
        ce0 => ce0,
        q0 => q0);

end architecture;


